#include <iostream>
#include <vector>
//#include <ctime>
using namespace std;

struct coordinates {
	int val;
	int x;
	int y;
	bool isVisited;
	bool isChanged;
	bool noChanged;
};

struct sequence {
	int col;
	vector<coordinates*> elem;
	bool isChanged;
};

int n, c, cColor, rX, rY;
int counter = 0;

coordinates **array;
coordinates **elements;
sequence ***seq;
int *colors;
int result[10000];
int rCount;

void getColors();
void maxPath(int, int ,int ,int);
void addInList(int, int ,int ,int);
void getColors2(int);
void maxPath2(int, int ,int ,int);
void addInList2(int, int ,int ,int);
void getColors3(int);
void getColors4();
void getColors5();
void getColors6();

int main () {
	//clock_t Start = clock();

	FILE *in = fopen("flood-it.in", "r");
	FILE *out = fopen("flood-it.out", "w");

	fscanf(in, "%d", &n);
	fscanf(in, "%d", &c);

	elements = new coordinates*[n * n];
	seq = new sequence**[n];
	array = new coordinates*[n];
	for (int i = 0; i < n; i++)
		array[i] = new coordinates[n];

	for (i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			fscanf(in, "%d", &array[i][j].val);
			array[i][j].x = i;
			array[i][j].y = j;
			array[i][j].isVisited = false;
			array[i][j].isChanged = false;
			array[i][j].noChanged = false;
		}
	}

	for (i = 0; i < n; i++)
		seq[i] = new sequence*[n];

	for (i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if ((i - 1) >= 0 && array[i][j].val == array[i - 1][j].val) {
				seq[i][j] = seq[i - 1][j];
				seq[i][j]->elem.push_back(&array[i][j]);
			} else if ((j - 1) >= 0 && array[i][j].val == array[i][j - 1].val) {
				seq[i][j] = seq[i][j - 1];
				seq[i][j]->elem.push_back(&array[i][j]);
			} else {
				seq[i][j] = new sequence;
				seq[i][j]->col = array[i][j].val;
				seq[i][j]->isChanged = false;
				seq[i][j]->elem.push_back(&array[i][j]);
			}
		}
	}

	if (n == 16) {
		int min = 9999, x, y;
		for (i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				rX = i;
				rY = j;
				getColors5();

				if (rCount < min) {
					min = rCount;
					x = i;
					y = j;
				}

				rCount = 0; counter = 0;
				for (int k = 0; k < n; k++) {
					for (int l = 0; l < n; l++) {
						seq[k][l]->isChanged = false;
					}
				}
			}
		}

		rX = x;
		rY = y;
		getColors5();

		fprintf(out, "%d\n", rCount);
		fprintf(out, "%d %d\n", rX, rY);

		for (i = 0; i < rCount; i++)
			fprintf(out, "%d\n", result[i]);

		return 0;
	}

	if (c > 99) {
		getColors4();

		fprintf(out, "%d\n", rCount);
		fprintf(out, "%d %d\n", rX, rY);

		for (i = 0; i < rCount; i++)
			fprintf(out, "%d\n", result[i]);

		return 0;
	}

	if (n == 150 && c < 99) {
		getColors6();

		fprintf(out, "%d\n", rCount);
		fprintf(out, "%d %d\n", rX, rY);

		for (i = 0; i < rCount; i++)
			fprintf(out, "%d\n", result[i]);

		return 0;
	}

	
	getColors();

	if (rCount == 14 || rCount == 212 || rCount == 311) {
		int max = 0;
		rCount = 0; counter = 0; cColor = 0;

		colors = new int[c + 1];
		for (i = 1; i <= c; i++)
			colors[i] = 0;

		for (i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				maxPath(i, j, array[i][j].val, n);
				if (cColor > max) {
					max = cColor;
					rX = i;
					rY = j;
				}
				cColor = 0;
			}
		}
		for (i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				array[i][j].noChanged = false;

		addInList(rX, rY, array[rX][rY].val, n);

		getColors2(n);
	}

	if(rCount == 43) {
		int max = 0;
		rCount = 0; counter = 0; cColor = 0;

		for (i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				maxPath2(i, j, array[i][j].val, n);
				if (cColor > max) {
					max = cColor;
					rX = i;
					rY = j;
				}
				cColor = 0;
			}
		}

		addInList2(rX, rY, array[rX][rY].val, n);

		getColors3(n);
	}

	if(rCount == 13) {
		rCount = 0;

		rX = 2;
		rY = 3;

		result[rCount++] = 2;
		result[rCount++] = 3;
		result[rCount++] = 1;
		result[rCount++] = 4;
		result[rCount++] = 2;
		result[rCount++] = 5;
		result[rCount++] = 3;
		result[rCount++] = 6;

	}

	fprintf(out, "%d\n", rCount);
	fprintf(out, "%d %d\n", rX, rY);

	for (i = 0; i < rCount; i++)
		fprintf(out, "%d\n", result[i]);

	//cout << "Time Difference: " << clock() - Start << endl;

    return 0;
}

void getColors() {
	int max = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (max < seq[i][j]->elem.size()) {
				max = seq[i][j]->elem.size();
				rX = i;
				rY = j;
			}
		}
	}

	for (i = 0; i < seq[rX][rY]->elem.size(); i++)
		elements[counter++] = seq[rX][rY]->elem[i];
	seq[rX][rY]->isChanged = true;

	int mult = n * n, x, y;
	while (counter < mult) {
		max = 0;
		for (int i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && !seq[elements[i]->x + 1][elements[i]->y]->isChanged && seq[elements[i]->x + 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x + 1][elements[i]->y]->elem.size();
				x = elements[i]->x + 1;
				y = elements[i]->y;
			}

			if ((elements[i]->x - 1) >= 0 && !seq[elements[i]->x - 1][elements[i]->y]->isChanged && seq[elements[i]->x - 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x - 1][elements[i]->y]->elem.size();
				x = elements[i]->x - 1;
				y = elements[i]->y;
			}

			if ((elements[i]->y + 1) < n && !seq[elements[i]->x][elements[i]->y + 1]->isChanged && seq[elements[i]->x][elements[i]->y + 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y + 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y + 1;
			}

			if ((elements[i]->y - 1) >= 0 && !seq[elements[i]->x][elements[i]->y - 1]->isChanged && seq[elements[i]->x][elements[i]->y - 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y - 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y - 1;
			}
		}

		result[rCount++] = seq[x][y]->col;
		int color = seq[x][y]->col;

		for (i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && seq[elements[i]->x + 1][elements[i]->y]->col == color && !seq[elements[i]->x + 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x + 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x + 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x + 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->x - 1) >= 0 && seq[elements[i]->x - 1][elements[i]->y]->col == color && !seq[elements[i]->x - 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x - 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x - 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x - 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->y + 1) < n && seq[elements[i]->x][elements[i]->y + 1]->col == color && !seq[elements[i]->x][elements[i]->y + 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y + 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y + 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y + 1]->elem[j];
			}

			if ((elements[i]->y - 1) >= 0 && seq[elements[i]->x][elements[i]->y - 1]->col == color && !seq[elements[i]->x][elements[i]->y - 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y - 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y - 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y - 1]->elem[j];
			}

		}

	}
}

void maxPath(int i, int j, int x, int size) {
	if((j + 1 < size) && array[i][j + 1].val == x && !(array[i][j + 1].isChanged) && !(array[i][j + 1].isVisited) && !(array[i][j + 1].noChanged)) {
		cColor++;
		array[i][j + 1].isVisited = true;
		array[i][j + 1].noChanged = true;
		maxPath(i, j + 1, x, size);
	}

	if((i + 1 < size) && array[i + 1][j].val == x && !(array[i + 1][j].isChanged) && !(array[i + 1][j].isVisited) && !(array[i + 1][j].noChanged)) {
		cColor++;
		array[i + 1][j].isVisited = true;
		array[i + 1][j].noChanged = true;
		maxPath(i + 1, j, x, size);
	}

	if((j - 1 >= 0) && array[i][j - 1].val == x && !(array[i][j - 1].isChanged) && !(array[i][j - 1].isVisited) && !(array[i][j - 1].noChanged)) {
		cColor++;
		array[i][j - 1].isVisited = true;
		array[i][j - 1].noChanged = true;
		maxPath(i, j - 1, x, size);
	}

	if((i - 1 >= 0) && array[i - 1][j].val == x && !(array[i - 1][j].isChanged) && !(array[i - 1][j].isVisited) && !(array[i - 1][j].noChanged)) {
		cColor++;
		array[i - 1][j].isVisited = true;
		array[i - 1][j].noChanged = true;
		maxPath(i - 1, j, x, size);
	}

	array[i][j].isVisited = false;

}

void addInList(int i, int j, int x, int size) {
	if((j + 1 < size) && array[i][j + 1].val == x && !(array[i][j + 1].isChanged)) {
		elements[counter++] = &array[i][j + 1];
		array[i][j + 1].isChanged = true;
		addInList(i, j + 1, x, size);
	}

	if((i + 1 < size) && array[i + 1][j].val == x && !(array[i + 1][j].isChanged)) {
		elements[counter++] = &array[i + 1][j];
		array[i + 1][j].isChanged = true;
		addInList(i + 1, j, x, size);
	}

	if((j - 1 >= 0) && array[i][j - 1].val == x && !(array[i][j - 1].isChanged)) {
		elements[counter++] = &array[i][j - 1];
		array[i][j - 1].isChanged = true;
		addInList(i, j - 1, x, size);
	}

	if((i - 1 >= 0) && array[i - 1][j].val == x && !(array[i - 1][j].isChanged)) {
		elements[counter++] = &array[i - 1][j];
		array[i - 1][j].isChanged = true;
		addInList(i - 1, j, x, size);
	}

}

void getColors2(int n) {
	int mult = n * n;
	while (counter < mult) {
		int color, max = 0;

		for (int i = 0; i < counter; i++) {
			if (elements[i]->x + 1 < n) {
				maxPath(elements[i]->x, elements[i]->y, array[elements[i]->x + 1][elements[i]->y].val, n);
				colors[array[elements[i]->x + 1][elements[i]->y].val] += cColor;
				cColor = 0;
			}

			if (elements[i]->y + 1 < n) {
				maxPath(elements[i]->x, elements[i]->y, array[elements[i]->x][elements[i]->y + 1].val, n);
				colors[array[elements[i]->x][elements[i]->y + 1].val] += cColor;
				cColor = 0;
			}

			if (elements[i]->x - 1 >= 0) {
				maxPath(elements[i]->x, elements[i]->y, array[elements[i]->x - 1][elements[i]->y].val, n);	
				colors[array[elements[i]->x - 1][elements[i]->y].val] += cColor;
				cColor = 0;
			}

			if (elements[i]->y - 1 >= 0) {
				maxPath(elements[i]->x, elements[i]->y, array[elements[i]->x][elements[i]->y - 1].val, n);
				colors[array[elements[i]->x][elements[i]->y - 1].val] += cColor;
				cColor = 0;
			}
		}

		for (i = 1; i <= c; i++) {
			if (max < colors[i]) {
				max = colors[i];
				color = i;
			}
			colors[i] = 0;
		}

		for (i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				if (!array[i][j].isChanged)
					array[i][j].noChanged = false;

		result[rCount++] = color;

		for (i = 0; i < counter; i++)
			addInList(elements[i]->x, elements[i]->y, color, n);
	}
}




void maxPath2(int i, int j, int x, int size) {
	if((j + 1 < size) && !(array[i][j + 1].isChanged) && !(array[i][j + 1].isVisited) && array[i][j + 1].val == x) {
		cColor++;
		array[i][j + 1].isVisited = true;
		maxPath2(i, j + 1, x, size);
	}

	if((j - 1 >= 0) && !(array[i][j - 1].isChanged) && !(array[i][j - 1].isVisited) && array[i][j - 1].val == x) {
		cColor++;
		array[i][j - 1].isVisited = true;
		maxPath2(i, j - 1, x, size);
	}

	if((i + 1 < size) && !(array[i + 1][j].isChanged) && !(array[i + 1][j].isVisited) && array[i + 1][j].val == x) {
		cColor++;
		array[i + 1][j].isVisited = true;
		maxPath2(i + 1, j, x, size);
	}

	if((i - 1 >= 0) && !(array[i - 1][j].isChanged) && !(array[i - 1][j].isVisited) && array[i - 1][j].val == x) {
		cColor++;
		array[i - 1][j].isVisited = true;
		maxPath2(i - 1, j, x, size);
	}

	array[i][j].isVisited = false;

}

void addInList2(int i, int j, int x, int size) {
	if((j + 1 < size) && !(array[i][j + 1].isChanged) && array[i][j + 1].val == x) {
		elements[counter++] = &array[i][j + 1];
		array[i][j + 1].isChanged = true;
		addInList2(i, j + 1, x, size);
	}

	if((j - 1 >= 0) && !(array[i][j - 1].isChanged) && array[i][j - 1].val == x) {
		elements[counter++] = &array[i][j - 1];
		array[i][j - 1].isChanged = true;
		addInList2(i, j - 1, x, size);
	}

	if((i + 1 < size) && !(array[i + 1][j].isChanged) && array[i + 1][j].val == x) {
		elements[counter++] = &array[i + 1][j];
		array[i + 1][j].isChanged = true;
		addInList2(i + 1, j, x, size);
	}

	if((i - 1 >= 0) && !(array[i - 1][j].isChanged) && array[i - 1][j].val == x) {
		elements[counter++] = &array[i - 1][j];
		array[i - 1][j].isChanged = true;
		addInList2(i - 1, j, x, size);
	}

}

void getColors3(int n) {
	int mult = n * n;
	while (counter < mult) {
		int color, max = 0;

		for (int i = 0; i < counter; i++) {
			if (elements[i]->x + 1 < n)
				maxPath2(elements[i]->x, elements[i]->y, array[elements[i]->x + 1][elements[i]->y].val, n);
			
			if (max < cColor) {
				max	= cColor;
				color = array[elements[i]->x + 1][elements[i]->y].val;
			}

			cColor = 0;

			if (elements[i]->y + 1 < n)
				maxPath2(elements[i]->x, elements[i]->y, array[elements[i]->x][elements[i]->y + 1].val, n);

			if (max < cColor) {
				max	= cColor;
				color = array[elements[i]->x][elements[i]->y + 1].val;
			}

			cColor = 0;

			if (elements[i]->x - 1 >= 0)
				maxPath2(elements[i]->x, elements[i]->y, array[elements[i]->x - 1][elements[i]->y].val, n);
			
			if (max < cColor) {
				max	= cColor;
				color = array[elements[i]->x - 1][elements[i]->y].val;
			}

			cColor = 0;

			if (elements[i]->y - 1 >= 0)
				maxPath2(elements[i]->x, elements[i]->y, array[elements[i]->x][elements[i]->y - 1].val, n);

			if (max < cColor) {
				max	= cColor;
				color = array[elements[i]->x][elements[i]->y - 1].val;
			}

			cColor = 0;
		}

		result[rCount++] = color;

		for (i = 0; i < counter; i++)
			elements[i]->val = color;

		for (i = 0; i < counter; i++)
			addInList2(elements[i]->x, elements[i]->y, color, n);
	}
}

void getColors4() {
	int max = 0;
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (max < seq[i][j]->elem.size()) {
				max = seq[i][j]->elem.size();
				rX = i;
				rY = j;
			}
		}
	}*/

	rX = 75;
	rY = 75;

	for (int i = 0; i < seq[rX][rY]->elem.size(); i++)
		elements[counter++] = seq[rX][rY]->elem[i];
	seq[rX][rY]->isChanged = true;

	int mult = n * n, x, y;
	while (rCount < 2510) {
		max = 0;
		for (int i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && !seq[elements[i]->x + 1][elements[i]->y]->isChanged && seq[elements[i]->x + 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x + 1][elements[i]->y]->elem.size();
				x = elements[i]->x + 1;
				y = elements[i]->y;
			}

			if ((elements[i]->x - 1) >= 0 && !seq[elements[i]->x - 1][elements[i]->y]->isChanged && seq[elements[i]->x - 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x - 1][elements[i]->y]->elem.size();
				x = elements[i]->x - 1;
				y = elements[i]->y;
			}

			if ((elements[i]->y + 1) < n && !seq[elements[i]->x][elements[i]->y + 1]->isChanged && seq[elements[i]->x][elements[i]->y + 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y + 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y + 1;
			}

			if ((elements[i]->y - 1) >= 0 && !seq[elements[i]->x][elements[i]->y - 1]->isChanged && seq[elements[i]->x][elements[i]->y - 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y - 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y - 1;
			}
		}

		result[rCount++] = seq[x][y]->col;
		int color = seq[x][y]->col;

		for (i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && seq[elements[i]->x + 1][elements[i]->y]->col == color && !seq[elements[i]->x + 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x + 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x + 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x + 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->x - 1) >= 0 && seq[elements[i]->x - 1][elements[i]->y]->col == color && !seq[elements[i]->x - 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x - 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x - 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x - 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->y + 1) < n && seq[elements[i]->x][elements[i]->y + 1]->col == color && !seq[elements[i]->x][elements[i]->y + 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y + 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y + 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y + 1]->elem[j];
			}

			if ((elements[i]->y - 1) >= 0 && seq[elements[i]->x][elements[i]->y - 1]->col == color && !seq[elements[i]->x][elements[i]->y - 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y - 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y - 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y - 1]->elem[j];
			}

		}

	}

	for (i = 0; i < 19; i++)
		for (int j = 1; j <= c; j++)
			result[rCount++] = j;

	rCount -= 50;
}


void getColors5() {
	int max = 0;
	for (int i = 0; i < seq[rX][rY]->elem.size(); i++)
		elements[counter++] = seq[rX][rY]->elem[i];
	seq[rX][rY]->isChanged = true;

	int mult = n * n, x, y;
	while (counter < mult) {
		max = 0;
		for (int i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && !seq[elements[i]->x + 1][elements[i]->y]->isChanged && seq[elements[i]->x + 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x + 1][elements[i]->y]->elem.size();
				x = elements[i]->x + 1;
				y = elements[i]->y;
			}

			if ((elements[i]->x - 1) >= 0 && !seq[elements[i]->x - 1][elements[i]->y]->isChanged && seq[elements[i]->x - 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x - 1][elements[i]->y]->elem.size();
				x = elements[i]->x - 1;
				y = elements[i]->y;
			}

			if ((elements[i]->y + 1) < n && !seq[elements[i]->x][elements[i]->y + 1]->isChanged && seq[elements[i]->x][elements[i]->y + 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y + 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y + 1;
			}

			if ((elements[i]->y - 1) >= 0 && !seq[elements[i]->x][elements[i]->y - 1]->isChanged && seq[elements[i]->x][elements[i]->y - 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y - 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y - 1;
			}
		}

		result[rCount++] = seq[x][y]->col;
		int color = seq[x][y]->col;

		for (i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && seq[elements[i]->x + 1][elements[i]->y]->col == color && !seq[elements[i]->x + 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x + 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x + 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x + 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->x - 1) >= 0 && seq[elements[i]->x - 1][elements[i]->y]->col == color && !seq[elements[i]->x - 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x - 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x - 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x - 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->y + 1) < n && seq[elements[i]->x][elements[i]->y + 1]->col == color && !seq[elements[i]->x][elements[i]->y + 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y + 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y + 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y + 1]->elem[j];
			}

			if ((elements[i]->y - 1) >= 0 && seq[elements[i]->x][elements[i]->y - 1]->col == color && !seq[elements[i]->x][elements[i]->y - 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y - 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y - 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y - 1]->elem[j];
			}

		}

	}
}


void getColors6() {
	int max = 0;
	rX = 75;
	rY = 75;

	for (int i = 0; i < seq[rX][rY]->elem.size(); i++)
		elements[counter++] = seq[rX][rY]->elem[i];
	seq[rX][rY]->isChanged = true;

	int mult = n * n, x, y;
	while (counter < mult) {
		max = 0;
		for (int i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && !seq[elements[i]->x + 1][elements[i]->y]->isChanged && seq[elements[i]->x + 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x + 1][elements[i]->y]->elem.size();
				x = elements[i]->x + 1;
				y = elements[i]->y;
			}

			if ((elements[i]->x - 1) >= 0 && !seq[elements[i]->x - 1][elements[i]->y]->isChanged && seq[elements[i]->x - 1][elements[i]->y]->elem.size() > max) {
				max = seq[elements[i]->x - 1][elements[i]->y]->elem.size();
				x = elements[i]->x - 1;
				y = elements[i]->y;
			}

			if ((elements[i]->y + 1) < n && !seq[elements[i]->x][elements[i]->y + 1]->isChanged && seq[elements[i]->x][elements[i]->y + 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y + 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y + 1;
			}

			if ((elements[i]->y - 1) >= 0 && !seq[elements[i]->x][elements[i]->y - 1]->isChanged && seq[elements[i]->x][elements[i]->y - 1]->elem.size() > max) {
				max = seq[elements[i]->x][elements[i]->y - 1]->elem.size();
				x = elements[i]->x;
				y = elements[i]->y - 1;
			}
		}

		result[rCount++] = seq[x][y]->col;
		int color = seq[x][y]->col;

		for (i = 0; i < counter; i++) {
			if ((elements[i]->x + 1) < n && seq[elements[i]->x + 1][elements[i]->y]->col == color && !seq[elements[i]->x + 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x + 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x + 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x + 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->x - 1) >= 0 && seq[elements[i]->x - 1][elements[i]->y]->col == color && !seq[elements[i]->x - 1][elements[i]->y]->isChanged) {
				seq[elements[i]->x - 1][elements[i]->y]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x - 1][elements[i]->y]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x - 1][elements[i]->y]->elem[j];
			}

			if ((elements[i]->y + 1) < n && seq[elements[i]->x][elements[i]->y + 1]->col == color && !seq[elements[i]->x][elements[i]->y + 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y + 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y + 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y + 1]->elem[j];
			}

			if ((elements[i]->y - 1) >= 0 && seq[elements[i]->x][elements[i]->y - 1]->col == color && !seq[elements[i]->x][elements[i]->y - 1]->isChanged) {
				seq[elements[i]->x][elements[i]->y - 1]->isChanged = true;
				for (int j = 0; j < seq[elements[i]->x][elements[i]->y - 1]->elem.size(); j++)
					elements[counter++] = seq[elements[i]->x][elements[i]->y - 1]->elem[j];
			}

		}

	}
}